$! APPEND_GROUP.COM
$! 02-10-1995, David Mathog, Biology Division, Caltech
$!
$! This appends group names on the end of any file that has usernames
$! down the first column.
$! It works only if
$! each group and user name has a unique identifier in the SYSUAF,
$! and if these match the ones on the Unix machine.
$!
$! P1 is input file, if present, default is BILLING (opens billing.dat or
$!    file specified by the logical.)
$! P1 is output file, if present, default is input file
$!
$!
$ if("''P1'" .nes. "")
$ then
$   modfile = P1
$ else
$   modfile = "BILLING"
$ endif
$ if("''P2'" .nes. "")
$ then
$   outfile = P2
$ else
$   outfile = modfile
$ endif
$ open/read tfil: 'modfile'
$ open/write ofil: temp.dat
$!
$top:
$   read/end=bye/error=oops tfil: string 
$   user = f$extract(0,8,string)
$   x = f$identifier(user,"name_to_number")
$   if(x .ne. 0)
$   then
$     x = ((x .and. %xFFFF0000) .or. %xFFFF)
$     group = f$identifier(x,"number_to_name")
$   else
$     group = "unknown"
$   endif
$   write ofil: string," ",group
$ goto top
$!
$bye:
$ close tfil:
$ close ofil:
$ write sys$output "Almost done, cleaning up..."
$ copy temp.dat 'outfile'
$ delete temp.dat.
$ exit
$!
$error:
$ close tfil:
$ close ofil:
$ write sys$output "Error reading ''modfile'"
$ write sys$output "deleting temporary file temp.dat"
$ delete temp.dat.
$ exit
